## opam 1.1.0

=== debian/changelog ===
opam (1.1.0-1) unstable; urgency=low

  * New upstream release.
    + Update patch (fix spelling errors).
  * Link against "re.str", added in debian/buildsys/myocamlbuild.ml.
  * Only install "opam" and "opam-admin" binaries, as upstream does.
  * Add build-essential to Depends and ocaml to Recommends.

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 24 Nov 2013 15:46:57 +0100

opam (1.0.0-1) unstable; urgency=low

  * Initial upload (Closes: #641986)

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 16 Jun 2013 15:03:14 +0200
