=== debian/changelog ===
opam (1.1.1-1) unstable; urgency=low

  * New upstream release.

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 02 Feb 2014 11:13:43 +0100
