=== debian/watch ===
version=3
https://github.com/ocamlpro/opam/tags/ /.*/([\d\.]+)\.tar\.gz
