=== debian/changelog ===
opam (1.1.2-1) UNRELEASED; urgency=low

  * Initial package

 -- Euan Harris <euan.harris@citrix.com>  Fri, 01 Aug 2014 12:00:00 +0000
